package vulnerability

import "github.com/aquasecurity/trivy-db/pkg/types"

const (
	// Data source
	NVD                   types.SourceID = "nvd"
	RedHat                types.SourceID = "redhat"
	RedHatOVAL            types.SourceID = "redhat-oval"
	Debian                types.SourceID = "debian"
	Ubuntu                types.SourceID = "ubuntu"
	CentOS                types.SourceID = "centos"
	Rocky                 types.SourceID = "rocky"
	Fedora                types.SourceID = "fedora"
	Amazon                types.SourceID = "amazon"
	OracleOVAL            types.SourceID = "oracle-oval"
	SuseCVRF              types.SourceID = "suse-cvrf"
	Alpine                types.SourceID = "alpine"
	ArchLinux             types.SourceID = "arch-linux"
	Alma                  types.SourceID = "alma"
	CBLMariner            types.SourceID = "cbl-mariner"
	Photon                types.SourceID = "photon"
	RubySec               types.SourceID = "ruby-advisory-db"
	PhpSecurityAdvisories types.SourceID = "php-security-advisories"
	NodejsSecurityWg      types.SourceID = "nodejs-security-wg"
	GHSA                  types.SourceID = "ghsa"
	GLAD                  types.SourceID = "glad"
	GoVulnDB              types.SourceID = "go-vulndb"
	OSV                   types.SourceID = "osv"
	Wolfi                 types.SourceID = "wolfi"

	// Ecosystem
	Npm      types.Ecosystem = "npm"
	Composer types.Ecosystem = "composer"
	Pip      types.Ecosystem = "pip"
	RubyGems types.Ecosystem = "rubygems"
	Cargo    types.Ecosystem = "cargo"
	NuGet    types.Ecosystem = "nuget"
	Maven    types.Ecosystem = "maven"
	Go       types.Ecosystem = "go"
	Rust     types.Ecosystem = "rust"
	Conan    types.Ecosystem = "conan"
	Erlang   types.Ecosystem = "erlang"
	Pub      types.Ecosystem = "pub"
)
